Summary: LSB Runtime Test Suites
Name: lsb-runtime-test
Version: 3.0.0
Release: 4
License: Artistic
Group: Development/Tools
Source0: install_scripts-3.0.0.tar.gz
Source1: build_scripts-3.0.0.tar.gz
Source2: lsb-runtime-tests-3.0.0.tar.gz
Source3: tjreport-1.4.tar.gz
URL: http://www.linuxbase.org/test
#Prefix: %{_prefix}
BuildRoot: %{_tmppath}/%{name}-root
AutoReqProv: no
Requires: lsb-tet3-lite
BuildRequires: lsb-tet3-lite
%define	tet_root	%{_libdir}/tet


%description

This is a binary version of the LSB runtime test suites. This version
is generated from the following source test suites:

lts_vsx-pcts-3.0.0.1.tgz - POSIX.1 test suite
lts_lsb-os-3.0.0.1.tgz - LSB-OS test suite
lts_lsb-fhs-3.0.0.1.tgz - FHS 2.2 test suite
lts_usersgroups-3.0.0.1.tgz - LSB Users/Groups test suites
lts_li18nux2k.l1-3.0.0.1.tgz - li18nux2k level 1 test suite
lts_vsthlite-3.0.0.1.tgz - VSTHlite test suite
lts_lsb-pam-3.0.0.1.tgz - LSB-PAM test suite

Header file tests from the test suites were removed as
this is an ABI test suite. 

The LSB.os aio tests are not run by default, but are available
separately by running the aio scenario.

*WARNING* This test suite contains a number of setuid and setgid
binaries some of which are owned by root or other users. Other setuid
and setgid binaries may be generated and left behind after execution
of the test suites (especially if certain tests fail). You should not
leave this package installed on production systems or in situations
where local users are not completely trusted.

The test suites use the following tet/vsxgen framework tarball to be 
build and run:

tet_vsxgen_3.6.tgz - tet/vsxgen framework

and install.sh script to be installed and setup.

#==================================================
%prep

LDSO_VERSION=3

%ifarch %{ix86}
LDSO=/lib/ld-lsb.so.$LDSO_VERSION
OLDSO=/lib/ld-linux.so.2
%endif
%ifarch ppc
LDSO=/lib/ld-lsb-ppc32.so.$LDSO_VERSION
OLDSO=/lib/ld.so.1
%endif
%ifarch ppc64
LDSO=/lib64/ld-lsb-ppc64.so.$LDSO_VERSION
OLDSO=/lib64/ld64.so.1
%endif
%ifarch s390
LDSO=/lib/ld-lsb-s390.so.$LDSO_VERSION
OLDSO=/lib/ld.so.1
%endif
%ifarch s390x
LDSO=/lib64/ld-lsb-s390x.so.$LDSO_VERSION
OLDSO=/lib/ld64.so.1
%endif
%ifarch ia64
LDSO=/lib/ld-lsb-ia64.so.$LDSO_VERSION
OLDSO=/lib/ld-linux-ia64.so.2
%endif
%ifarch x86_64
LDSO=/lib64/ld-lsb-x86-64.so.$LDSO_VERSION
OLDSO=/lib64/ld-linux-x86-64.so.2
%endif

cat > LDSOFILE << EOF
LDSO=$LDSO
OLDSO=$OLDSO
EOF

set +x
echo
echo In order to build this RPM you will need to be logged in
echo as root. During the building of the package /home/tet will
echo be removed.
echo
echo Note that if it is necessary the build process will create
echo 'vsx0 accounts and set the password to a default value (lsbtest).'
echo It is highly recommended that you immediately set the password
echo to something else.
echo 

printf "Do you wish to continue (y/n)? [n] "
read cmd
if [ "$cmd" = "y" -o "$cmd" = "Y" ]; then
  echo Build continuing.
  rm -rf /home/tet
else
  echo Aborting build.
  exit 1
fi
set -x

if [ ! -x /usr/bin/expect ]; then
  echo Could not find expect which is required to build the package
  exit 1
fi

SPECFILE=`gcc -v 2>&1 | head -1 | cut -d " " -f 4`
LDSO_NOW=`grep $LDSO $SPECFILE`
	
if [ -z "$LDSO_NOW" ]
then
	echo "You have not set your build environment to link to $LDSO"
	echo "Please replace the -dynamic-linker setting with $LDSO in $SPECFILE file"
	exit 1
fi

if [ ! -e $LDSO ]
then
	echo "Cannot find $LDSO file on your system"
	echo "Please install the distro lsb support package, create a symbolic"
	echo "link to $OLDSO or install the lsb-dummy package"
	exit 1
fi

# 
%setup -q -c 
%setup -D -b 1 -c
%setup -D -b 2 -c
%setup -D -b 3 -c


#==================================================
%build

./auto_install_test_suites
cp auto_configure_test_suites /home/tet/test_sets
su -c ./auto_configure_test_suites - vsx0
su -c '. profile; tccb -p' - vsx0

chown vsx0:vsxg0 *

cp /home/tet/test_sets/DOCS/vsxgde-1.0.pdf .

# Do architecture specific configuration
# (Eg settings in tetexec.cfg file)
./set_config_for_arch

#----------- tet

#==================================================
%install
# uncomment later
# rm -rf ${RPM_BUILD_ROOT}

mkdir -p ${RPM_BUILD_ROOT}/home/tet
chown vsx0:vsxg0 ${RPM_BUILD_ROOT}/home/tet
rsync -a /home/tet ${RPM_BUILD_ROOT}/home

# Omit the hdr file tests and utilities which are not part of the LSB spec
egrep -v "ANSI.hdr|POSIX.hdr|PTHR.hdr|LI18NUX2K.L1/(hdr|gui)/|LI18NUX2K.L1/utils/(ed|ex|vi|nm)" ${RPM_BUILD_ROOT}/home/tet/test_sets/scen.exec > /tmp/scen.exec.$$

# move the aio tests into a new section
grep -v /aio/ /tmp/scen.exec.$$ | sed -e 's/LSB.os 908/LSB.os 785/' > /tmp/scen.exec.new.$$
cat >> /tmp/scen.exec.new.$$ <<EOF
aio
        "total tests in LSB.os 123"
EOF
grep /aio/ /tmp/scen.exec.$$ >> /tmp/scen.exec.new.$$
cp /tmp/scen.exec.new.$$ ${RPM_BUILD_ROOT}/home/tet/test_sets/scen.exec
rm -f /tmp/scen.exec.$$ /tmp/scen.exec.new.$$

# move the syslog tests into a new section
cp ${RPM_BUILD_ROOT}/home/tet/test_sets/scen.exec /tmp/scen.exec.$$
egrep -v "syslog|openlog|closelog" /tmp/scen.exec.$$ | sed -e 's/LSB.os 785/LSB.os 661/' > /tmp/scen.exec.new.$$
cat >> /tmp/scen.exec.new.$$ <<EOF
syslog
        "total tests in LSB.os 248"
EOF
egrep "syslog|openlog|closelog" /tmp/scen.exec.$$ >> /tmp/scen.exec.new.$$
cp /tmp/scen.exec.new.$$ ${RPM_BUILD_ROOT}/home/tet/test_sets/scen.exec
rm -f /tmp/scen.exec.$$ /tmp/scen.exec.new.$$

# Omit the gets file interface tests which are not part of the LSB spec
egrep -v "ANSI.os/streamio/(Mgets|gets)/T.gets" ${RPM_BUILD_ROOT}/home/tet/test_sets/scen.exec > /tmp/scen.exec.$$

# adjust the test counts
cat /tmp/scen.exec.$$ | sed -e 's/ANSI.os 1536/ANSI.os 1522/' > /tmp/scen.exec.new.$$

cp /tmp/scen.exec.new.$$ ${RPM_BUILD_ROOT}/home/tet/test_sets/scen.exec
rm -f /tmp/scen.exec.$$ /tmp/scen.exec.new.$$

# Delete the ANSI.hdr and POSIX.hdr tests
rm -rf ${RPM_BUILD_ROOT}/home/tet/test_sets/TESTROOT/tset/ANSI.hdr
rm -rf ${RPM_BUILD_ROOT}/home/tet/test_sets/TESTROOT/tset/POSIX.hdr

# Delete the VSTHlite PTHR.hdr tests
rm -rf ${RPM_BUILD_ROOT}/home/tet/test_sets/TESTROOT/tset/PTHR.hdr

# Delete the li8nux2k.l1 hdr and gui tests
rm -rf ${RPM_BUILD_ROOT}/home/tet/test_sets/TESTROOT/tset/LI18NUX2k.L1/hdr
rm -rf ${RPM_BUILD_ROOT}/home/tet/test_sets/TESTROOT/tset/LI18NUX2k.L1/gui

cp post_install.sh ${RPM_BUILD_ROOT}/home/tet/test_sets/BIN/
chmod a+x ${RPM_BUILD_ROOT}/home/tet/test_sets/BIN/post_install.sh
cp /home/tet/test_sets/SRC/install/scripts/editcfg.sh ${RPM_BUILD_ROOT}/home/tet/test_sets/BIN/
# Tailor run_tests script for architecture
cp .profile ${RPM_BUILD_ROOT}/home/tet/test_sets
. ../LDSOFILE
cat > change_ldso.sh << EOF
sed -e "s@BUILD_VERSION=@BUILD_VERSION=\"${RPM_PACKAGE_VERSION}-${RPM_PACKAGE_RELEASE} ($RPM_ARCH)\"@" -e "s@^LDSO=@LDSO=\"$LDSO\"@" -e "s@^OLDSO=@OLDSO=\"$OLDSO\"@"  run_tests > ${RPM_BUILD_ROOT}/home/tet/test_sets/run_tests
EOF
chmod a+x change_ldso.sh && ./change_ldso.sh && rm -f change_ldso.sh
rm -f ../LDSOFILE
chmod a+x ${RPM_BUILD_ROOT}/home/tet/test_sets/run_tests

mkdir -p $RPM_BUILD_ROOT/usr/share/doc/lsb-runtime-test/
cp Artistic README vsxgde-1.0.pdf $RPM_BUILD_ROOT/usr/share/doc/lsb-runtime-test

# Copy the li18nux pseudo languages that we need
cp /home/tet/test_sets/tset/LI18NUX2K.L1/base/nl_langinfo/LTP_IL* ${RPM_BUILD_ROOT}/home/tet/LSB.tools/li18nux_psldefs/

#==================================================
%clean
# uncomment later. leave in now for speed
rm -rf ${RPM_BUILD_ROOT}
#rm -rf /home/tet

#======================================================================
%pre

# Need to create some groups and users beforehand because
# when the files are unpacked they need to be owned by the correct user
mkdir -p /home/tet/test_sets
groupadd vsxg0 > /dev/null 2>&1 || true
groupadd vsxg1 > /dev/null 2>&1 || true
groupadd vsxg2 > /dev/null 2>&1 || true
useradd -g vsxg0 -d /home/tet/test_sets -s /bin/sh -c "VSX0 test login" vsx0 > /dev/null 2>&1 || true
useradd -g vsxg1 -d /home/tet -s /bin/sh -c "VSX1 test login" vsx1 > /dev/null 2>&1 || true
useradd -g vsxg2 -d /home/tet -s /bin/sh -c "VSX2 test login" vsx2 > /dev/null 2>&1 || true


#======================================================================
%post

# Do post install setup
/home/tet/test_sets/BIN/post_install.sh

echo
echo You have added 3 user accounts into your system: vsx0, vsx1 and vsx2,
echo which are needed during the tests. But no password has been set for them.
echo 
echo Before run the tests, please choose a robust password for these users.
echo For example a combination of digits and upper and lower case letters.
echo 
echo To run the tests, please log in as vsx0 and follow the displayed instructions,
echo or su to vsx0 from root.
echo

# After new installation the test suites are no longer configured, so
# we remove this file
rm -f /home/tet/test_sets/.configured

#==================================================
%files
# %defattr(-,root,root)
/home/tet/test_sets/BIN
/home/tet/test_sets/TESTROOT
/home/tet/test_sets/scripts
/home/tet/test_sets/profile
/home/tet/test_sets/loopback_disk.ext2
/home/tet/test_sets/scen.exec
/home/tet/test_sets/tet_code
/home/tet/test_sets/.profile
/home/tet/test_sets/run_tests
/home/tet/test_sets/MAN

%dir /home/tet
%dir /home/tet/test_sets
%dir /home/tet/test_sets/results

# Need pseudo language stuff
/home/tet/LSB.tools/psldefs
/home/tet/LSB.tools/li18nux_psldefs

/usr/share/doc/lsb-runtime-test/Artistic
/usr/share/doc/lsb-runtime-test/README
/usr/share/doc/lsb-runtime-test/vsxgde-1.0.pdf

#==================================================
%changelog
* Wed May 5 2004 Chris Yeoh <cyeoh@samba.org>
- Second beta of 2.0 test suites

* Wed Mar 17 2004 Chris Yeoh <cyeoh@samba.org>
- First beta of 2.0 test suites

* Mon Jul 17 2003 Chris Yeoh <cyeoh@samba.org
- Updated test suites for 1.3.6 release

* Mon Apr 14 2003 Chris Yeoh <cyeoh@samba.org
- Updated test suites for 1.3.5 release

* Mon Mar 3 2003 Chris Yeoh <cyeoh@samba.org>
- Updated test suites for 1.3.4 release

* Wed Jan 15 2003 Chris Yeoh <cyeoh@samba.org>
- Updated test suites

* Wed Dec 4 2002 Chris Yeoh <cyeoh@samba.org>
- Update for new lsb-os, vsx-pcts, li8nux2k and lsb-fhs test suites
- Now installs required li8nux2k locales before tests executed.

* Thu Nov 21 2002 Chris Yeoh <cyeoh@samba.org>
- Adds vsthlite test suite
- Adds li8nux2k.l1 test suite
- LSB 1.3 Beta program

* Wed Oct 23 2002 Chris Yeoh <cyeoh@samba.org>
- Update for new lsb-os, vsx-pcts test suites
- Updated TET/VSXgen tarball to support testing on implementations that
  use function descriptors

* Fri Sep 20 2002 Chris Yeoh <cyeoh@samba.org>
- Update for new lsb-os, vsx-pcts, usersgroups and fhs test suites
- Adds MAN pages back into binary package as these are used
  by vrpt test tool.

* Thu Jun 27 2002 Chris Yeoh <cyeoh@samba.org>
- Incorporates fix from lsb-fhs-1.2.2.1 so that
  optional c shell support can be disabled correctly

* Mon Jun 17 2002 Chris Yeoh <cyeoh@samba.org
- Incorporates tet_vsxgen 2.3 (PPC32 stdarg fix)
- Incorporates fix for run_tests IA64 fix

* Wed May 29 2002 Chris Yeoh <cyeoh@samba.org>
- Update for new lsb-os, usersgroups and lsb-fhs test suites

* Wed May 1 2002 Chris Yeoh <cyeoh@samba.org>
- Update for new lsb-os, vsx-pcts and lsb-fhs test suites

* Tue Apr 23 2002 Chris Yeoh <cyeoh@samba.org>
- Update for new lsb-os, vsx-pcts and usersgroups test suites

* Sun Apr 7 2002 Chris Yeoh <cyeoh@samba.org>
- Update for new lsb-os, vsx-pcts and tet_vsxgen
- Adds better error reporting/checking to running of test 
  suites

* Wed Mar 13 2002 Chris Yeoh <cyeoh@samba.org>
- Rebuild for updated lsb-os and vsx-pcts test suites
- Removal of automatic running of aio tests
- Renaming of package to lsb-runtime-test to be more consistent
  with wider LSB naming scheme

* Tue Mar 12 2002 Chris Yeoh <cyeoh@samba.org>
- Adds automatic marking of package version into journal

* Tue Feb 12 2002 Chris Yeoh <cyeoh@samba.org>
- Fix creation of home directories fro vsx1, vsx2 in preinstall script
- Invalidate configuration on installation/upgrade
- Add tjreport
- Rebuild with updated lsb-os test suite

* Thu Jan 24 2002 Chris Yeoh <cyeoh@samba.org>
- Update for updated lsb-os test suite (minor change)
- Recompile with fixed stub libraries

* Fri Jan 18 2002 Chris Yeoh <cyeoh@samba.org>
- Update for updated usersgroups and fhs test suites
- Recompile with dynamically linked getspnam
- Update documentation

* Mon Dec 17 2001 Chris Yeoh <cyeoh@samba.org>
- Adds /sbin and /usr/sbin to path for vsx0 user
- Compiled with PATH_MAX set to 4096

* Thu Dec 13 2001 Chris Yeoh <cyeoh@samba.org>
- Update for new lsb-os release
- Add vsxgde-1.0.pdf in rpm
- Add lsb-fhs questions on first run of tests
- No longer include header file tests

* Mon Dec 3 2001 Chris Yeoh <cyeoh@samba.org>
- Fixes source build problem where vsx users do not already exist
- Checks for expect before building
- Clarifies post installation message to make it clearer as to what to do
  next

* Tue Nov 27 2001 Chris Yeoh <cyeoh@samba.org>
- Updates RPM to build test suites totally from source

* Wed Oct 10 2001 Chris Yeoh <cyeoh@samba.org>
- Adds lsb-fhs and lsb-usersgroups test suites
- Updates other test suites and tet/vsxgen harness

* Wed Jun 6 2001 Chris Yeoh <cyeoh@samba.org>
- Update for new source test suites. Now includes
  lsb-os test suite
- Various bug fixes of installation/setup scripts

* Wed May 9 2001 Chris Yeoh <cyeoh@samba.org>
- Create.

